/******************************************************************************
 *	tmenu.c:	^Cgtj[̏o
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 *
 *	@\:
 *	SX-WINDOWł悭g^Cgtj[̏õTvłB
 *	ꕶgpăV[gJbgL[̗LA`FbN}[NAđI
 *	sڂw肵Ă܂B
 *	ڂ̋؂蕶́AJ}i,jki\0jłB
 *
 *	gp@:
 *	}EX̉E{^ƃj[\AIƃEBhE
 *	ɃbZ[W\܂B
 *	Is̍ڂ́Aŕ\Ił܂B
 *	܂AL[_ECxgʂăV[gJbgL[̑ΉĂ܂B
 *	[OPT.1]{[M]L[Ńj[QIꂽƓs܂B
 */
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <sxmemory.h>		/* }𗘗pƂɕKv	*/
#include <event.h>		/* Cxg}𗘗pƂɕKv	*/
#include <sxgraph.h>		/* Otn}l[W𗘗pƂɕKv */
#include <window.h>		/* EBhE}𗘗pƂɕKv	*/
#include <menu.h>		/* j[}𗘗pƂɕKv	*/
#include <dialog.h>		/* _CAO}𗘗pƂɕKv	*/
#include <task.h>		/* ^XN}𗘗pƂɕKv	*/
#include "tmenu.h"		/* ̃vOŗL̃wb_t@C	*/

char _sxkernelcomm[] = SXKERNEL;	/* J[lNR}h		*/

/******************************************************************************
 *	main():		C֐
 ******************************************************************************
 */
int main(void)
{
	ComVal cv;			/* ʕϐ			*/

	if (!init(&cv)) {		/* s		*/
		showErrDialog(&cv);	/* G[_CAO\	*/
		cv.endFlag = TRUE;	/* ItOZbg	*/
	}
	/* ItOZbg܂Ń[v */
	while (!cv.endFlag) {
		cv.errorCode = 0;	/* G[R[hNA	*/
		/* ^XN}Cxg擾 */
		TSEventAvail(cv.eventMask, &cv.event);
		/* JgOtɂ */
		GMSetGraph(&cv.windowPtr->graph);

		/* eCxgɑΉs */
		switch (cv.event.ts.what) {
		case E_MSLDOWN:		/* }EXtg_ECxg	*/
			msLDownEvent(&cv);
			break;
		case E_MSRDOWN:		/* }EXCg_ECxg	*/
			msRDownEvent(&cv);
			break;
		case E_KEYDOWN:		/* L[_ECxg		*/
			keyDownEvent(&cv);
			break;
		case E_UPDATE:		/* Abvf[gCxg		*/
			updateEvent(&cv);
			break;
		case E_ACTIVATE:	/* ANeBx[gCxg	*/
			activateEvent(&cv);
			break;
		case E_SYSTEM1:		/* VXeCxg		*/
		case E_SYSTEM2:
			systemEvent(&cv);
			break;
		}
		if (cv.errorCode != 0)	/* G[H		*/
			showErrDialog(&cv); /* G[_CAO\ */
	}
	/* I葱s */
	endProc(((cv.errorCode == 0) ? EXIT_SUCCESS : EXIT_FAILURE), &cv);

	return 0;
}

/******************************************************************************
 *	init():		
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  
 *				= FALSE: siIj
 *	:	ʕϐ̏AA{[g֐̓o^AEBhE̍쐬
 *		\ȂǂsB
 */
BOOLEAN init(ComVal *pcv)
{
	pcv->windowPtr = NULL;		/* EBhE|C^		*/
	pcv->activeFlag = FALSE;	/* ANeButO		*/
	pcv->eventMask = EVENTMASK;	/* Cxg}XN		*/
	pcv->errorCode = 0;		/* G[R[h			*/
	pcv->endFlag = FALSE;		/* ItO			*/
	pcv->lastMenu = 0;		/* OIj[ԍ	*/
	pcv->checkMark = 0;		/* `FbN}[Nt̃j[ԍ */

	TSSetAbort(endProc, (long) pcv); /* A{[g֐o^	*/

	if (LOWWORD(SXVer()) < SXVER2) { /* rwVXẽo[W𒲂ׂ */
		pcv->errorCode = 1;	/* o[WQÂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}
	if (!createWindow(pcv)) {	/* EBhE쐬		*/
		pcv->errorCode = 2;	/* 쐬łȂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}

	GMSetGraph(&pcv->windowPtr->graph); /* JgOtɂ */
	GMForeColor(G_BLACK);		/* tHAOEhJ[ɂ */
	/* obNOEhJ[CgO[ɂ */
	GMBackColor(G_LGRAY);
	GMFontMode(G_PSET);		/* tHg[hPSETɂ	*/

	WMShow(pcv->windowPtr);		/* EBhE\		*/
	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	createWindow():	EBhE̍쐬
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬siIj
 */
BOOLEAN createWindow(ComVal *pcv)
{
	int paramFlags;			/* p[^̗L		*/
	Rect rc;
	Task task;			/* ^XNǗR[h		*/

	static Rect winSize = { 0, 0, WIN_H, WIN_V }; /* EBhETCY */

	TSGetTdb(&task, TS_OWN);	/* ^XNǗR[h擾	*/
	paramFlags = TSTakeParam(	/* R}hC͂	*/
		task.command,		/* R}hC		*/
		&rc,			/* w肳ꂽEBhEʒu	*/
		NULL,			/* ŏIi[Ȃ	*/
		0,			/* AhXe[uۑȂ	*/
		NULL,			/* AhXe[u쐬Ȃ	*/
		NULL);			/* |C^mۂȂ		*/
	if (!(paramFlags & 1)) {	/* EBhEʒu̎w肪邩H */
		/* ȂꍇAVXeEBhE̍W擾 */
		rc = winSize;
		GMSlideRect(&rc, TSGetWindowPos());
	}

	pcv->windowPtr = WMOpen(	/* EBhEI[v	*/
		NULL,			/* EBhE|C^mۂ	*/
		&rc,			/* EBhE̕\ʒu		*/
		WINTITLE,		/* EBhE^Cg		*/
		FALSE,			/* I[vɕ`悵Ȃ	*/
		WI_STD2 << 4,		/* ^Cg̍LWEBhE	*/
		W_FRONT,		/* ԎOɕ\		*/
		TRUE,			/* N[Y{^gp	*/
		TSGetID());		/* ̃^XNhc		*/
	if (pcv->windowPtr == NULL)
		return FALSE;		/* ŝFALSEԂ	*/

	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	msLDownEvent():	}EXtg_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:
 *	EBhEŃ}EX̍{^ꂽꍇ̏sB
 *	̏ŃN[Y{^ɂIAEBhËړ\ƂȂ܂B
 */
void msLDownEvent(ComVal *pcv)
{
	int partCode;			/* EBhẼp[gR[h	*/
	Window *wTemp;			/* e|EBhE|C^	*/

	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		/* EBhECANeBuŁAOPT.1L[ĂȂH */
		if (!pcv->activeFlag && !(pcv->event.ev.how & KS_OPT1)) {
			/* EBhEANeBuɂ */
			WMSelect(pcv->windowPtr);
			/* {^ꂽꏊ̃p[gR[h擾 */
			partCode = WMFind(pcv->event.ev.where.x_y, &wTemp);
			/* ^Cgo[ȊOA{^ꂽH */
			if (partCode != W_INDRAG || !EMLStill())
				return;
		}
		/* }EX̃{^ĂԁAEBhE̊e폈
		   VXeɔCāA{^ꂽA܂͗ꂽꏊ
		   p[gR[h擾 */
		partCode = SXCallWindM(pcv->windowPtr, &pcv->event);
		if (partCode == W_INCLOSE) /* N[Y{^H	*/
			pcv->endFlag = TRUE; /* ItOZbg	*/
	}
}

/******************************************************************************
 *	msRDownEvent():	}EXCg_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	EBhEŃ}EX̉E{^ꂽꍇ̏sB
 */
void msRDownEvent(ComVal *pcv)
{
	/* Cxg̃EBhEŁA
	   EBhEANeBuAOPT.1L[ꂽH */
	if (pcv->event.ev.whom.win == pcv->windowPtr
	 && (pcv->activeFlag || pcv->event.ev.how & KS_OPT1))
		selectMenu(pcv);	/* j[̍쐬ƑIs */
}

/******************************************************************************
 *	selectMenu():	|bvAbvj[̍쐬ƑI
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void selectMenu(ComVal *pcv)
{
	int i;
	int num;			/* j[̃ACeԍ	*/
	Rect rc;
	Menu **menuHdl;			/* j[nh		*/
	char str[256];

	/* ej[ACe̓ꕶ́Â悤ȈӖB
	 *	'~'Ŏn܂ACe̓CANeBuɂȂ
	 *	iŕ\AIłȂȂj
	 *	'!'̓`FbN}[N\
	 *	'^'ɑPV[gJbgL[Ƃĕ\
	 * ܂j[ACéAJ}i','jki\0jŋ؂
	 */
	static char *menuItem[5] = {	/* j[ACe		*/
		"j[P,",
		"^Mj[Q,",
		"~j[R,",
		"~ ,",
		"j[T"
	};

	/* j[`̍쐬 */
	str[0] = 0;
	for (i = 0; i < 5; i++) {
		if (i == pcv->checkMark - 1)
			strcat(str, "!"); /* `FbN}[N\	*/
		strcat(str, menuItem[i]);
	}
	menuHdl = MNConvert(		/* j[쐬		*/
		NULL,			/* j[nhmۂ	*/
		str,			/* j[`		*/
		MI_TTL);		/* ^Cgt̃\[Xhc	*/
	if (menuHdl == NULL) {
		pcv->errorCode = 6;	/* 쐬łȂ		*/
		pcv->endFlag = TRUE;	/* ItOZbg	*/
		return;
	}
	(*menuHdl)->defData = (long) MTITLE; /* j[^Cgݒ肷 */
	num = MNSelect(			/* j[̕\ƑIs	*/
		menuHdl,		/* j[nh		*/
		pcv->event.ev.where.x_y); /* }EX̉E{^ꂽʒu */
	MMHdlDispose(menuHdl);		/* j[nh	*/
	switch (num) {
	case 1:				/* j[P			*/
	case 2:				/* j[Q			*/
	case 3:				/* j[R			*/
	case 4:				/* j[S			*/
	case 5:				/* j[T			*/
		/* IꂽACeԍɃ`FbN}[N */
		pcv->checkMark = num;
		break;
	}
	if (pcv->lastMenu != num) {	/* OƈႤACeIꂽH */
		pcv->lastMenu = num;	/* IꂽACeԍۑ */
		/* EBhEŜ */
		rc = pcv->windowPtr->graph.rect;
		/* O[oWnɕϊ */
		GMSlideRect(&rc, GMLocalToGlobal(0));
		WMAddRect(&rc);		/* Abvf[g[Wɒǉ */
	}
}

/******************************************************************************
 *	keyDownEvent():	L[_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	j[̃V[gJbgƁAOPT.1+'Q'L[ł̏IsB
 */
void keyDownEvent(ComVal *pcv)
{
	int shortCut;			/* V[gJbgL[		*/

	if (pcv->event.ev.how & KS_OPT1) { /* OPT.1L[ꂽH	*/
		/* L[͂啶ɕϊ */
		shortCut = toupper((int) pcv->event.ev.whom.key.ascii);
		switch (shortCut) {
		case 'Q':		/* I				*/
			pcv->endFlag = TRUE; /* ItOZbg	*/
			break;
		/* j[̃V[gJbgɑΉ */
		case 'M':		/* j[Q			*/
			pcv->lastMenu = 2;
			pcv->checkMark = 2;
			drawGraph(pcv);	/* Iꂽڂ𕶎ŕ\ */
			break;
		}
	}
}

/******************************************************************************
 *	updateEvent():	Abvf[g
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:
 *	Abvf[gƂăEBhE`悷B
 *	̏sȂƁA艺̃EBhẼAbvf[gACh
 *	Cxg̏łȂȂ܂B
 */
void updateEvent(ComVal *pcv)
{
	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		WMUpdate(pcv->windowPtr); /* Abvf[gJn	*/
		drawGraph(pcv);		/* EBhE`悷	*/
		WMUpdtOver(pcv->windowPtr); /* Abvf[gI	*/
	}
}

/******************************************************************************
 *	drawGraph():	EBhE̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void drawGraph(ComVal *pcv)
{
	char str1[64], str2[64];

	/* JgOt́Ałɐݒ肳Ă */

	switch (pcv->lastMenu) {
	case 1:				/* j[P			*/
	case 2:				/* j[Q			*/
	case 3:				/* j[R			*/
	case 4:				/* j[S			*/
	case 5:				/* j[T			*/
	case 6:				/* j[U			*/
		sprintf(str1, "j[ %d ԖڂI܂B", pcv->lastMenu);
		break;
	default:
		if (pcv->checkMark == 0)
			str1[0] = 0;	/* ܂xj[I΂ĂȂ */
		else
			strcpy(str1, "j[͑I܂łB");
		break;
	}
	sprintf(str2, "%-35s", str1);
	GMMove(LONGWORD(20, 15));
	GMDrawStrZ(str2);
}

/******************************************************************************
 *	activateEvent():	ANeBx[gCxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	ANeBuACANeBuɂANeButO̐؂ւƁA
 *		Cxg}XN̐؂ւsB
 */
void activateEvent(ComVal *pcv)
{
	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		pcv->activeFlag = TRUE;	/* ANeButOZbg	*/
		/* ANeBũCxg}XNZbg */
		pcv->eventMask = EVENTMASK | EM_KEYDOWN;
	/* Cxg̃EBhEŁAANeBuԂH */
	} else if (pcv->activeFlag) {
		pcv->activeFlag = FALSE; /* ANeButONA */
		/* CANeBũCxg}XNZbg */
		pcv->eventMask = EVENTMASK;
	}
}

/******************************************************************************
 *	systemEvent():	VXeCxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	SEBhẼN[YAS^XN̏IAEBhẼZNg
 *		ΉsB
 */
void systemEvent(ComVal *pcv)
{
	switch (pcv->event.ts.what2) {	/* Cxg̎ނ́H		*/
	case CLOSEALL:			/* SEBhẼN[Y	*/
	case ENDTSK:			/* S^XN̏I		*/
		pcv->endFlag = TRUE;	/* ItOZbg	*/
		break;
	case WINDOWSELECT:		/* EBhẼZNg		*/
		WMSelect(pcv->windowPtr); /* EBhEANeBuɂ */
		break;
	}
}

/******************************************************************************
 *	showErrDialog():	G[_CAO̕\
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void showErrDialog(ComVal *pcv)
{
	int i;

	static struct {			/* G[			*/
		int code;		/* G[R[h			*/
		int manager;		/* gp}l[W		*/
		int flag;		/* \tbO			*/
		char *message;		/* G[bZ[W		*/
	} errInfo[] = {
		{ 1, 1, D_RED,    "SX SYSTEM̃o[WႢ܂B" },
		{ 2, 2, D_RED,    "EBhE쐬ł܂B" },
		{ 6, 1, D_RED,    "j[쐬ł܂B" },
		{ 0, 1, D_YELLOW, "G[܂B" }
	};

	for (i = 0; errInfo[i].code != 0; i++) /* G[R[h{	*/
		if (errInfo[i].code == pcv->errorCode)
			break;
	switch (errInfo[i].manager) {	/* }l[W̑I		*/
	case 1:				/* _CAO}		*/
		DMError(errInfo[i].flag | D_CONFIRM, errInfo[i].message);
		break;
	case 2:				/* ^XN}			*/
		TSErrDialogN(errInfo[i].flag | D_CONFIRM, errInfo[i].message);
		break;
	}
}

/******************************************************************************
 *	endProc():	I葱
 ******************************************************************************
 *	:	int code	IR[h
 *		ComVal *pcv	ʕϐւ̃|C^
 *	:	nh̉EBhE̔pƁAvȌIsB
 */
void endProc(int code, ComVal *pcv)
{
	/* EBhE|C^mۂꂽ܂܂H */
	if (pcv->windowPtr != NULL)
		WMDispose(pcv->windowPtr); /* EBhEp	*/

	exit(code);			/* vOI		*/
}
